// Custom AI functions for Dune Sea - starstriker1

//This function looks through the wanted set, and finds items that the AI
//still needs to get to complete the set.
//Based off AINeedEquipment, except it returns the ITEM, instead of true/false
function AINeedWhatEquipment(%equipmentList, %client)
{
   %index = 0;
   %item = getWord(%equipmentList, %index);

	//first, see if we're testing the armor class as well...
	if (%item $= "Heavy" || %item $= "Medium" || %item $= "Light")
	{
		if (%client.player.getArmorSize() !$= %item)
			return %item;
		%index++;
	   %item = getWord(%equipmentList, %index);
	}

   while (%item !$= "")
   {
      if (%client.player.getInventory(%item) == 0)
      {
            echo("AI needs a:" @ %item);
			return %item;
      }

      //get the next item
      %index++;
      %item = getWord(%equipmentList, %index);
   }

	//made it through the list without needing anything
	return "";
}

//Figures out what can be dropped
function AIDropUnwantedWeapons(%equipmentList, %client)
{
   %haveIndex = 0; //First weapon in list of possible equipment
   %haveItem = getWord(%AIEquipmentList, %haveIndex);

   //First, we need to establish what we have
   while (%haveItem !$= "")
   {
      if (%client.player.getInventory(%haveItem) == 1)
      {
      //We've now found an item in our inventory
      //Now we check it against the list of wanted equipment to see if
      //its okay to drop it.
            %index = 0; //First Weapon on wanted list
            %item = getWord(%equipmentList, %index);
            
            %isWanted = 0;
            while (%item !$= "")
            {
                   if (%item $= %haveItem) //If you want this item
                   {
                   %item = ""; //End the loop
                   %isWanted = 1;
                   }
                   else //If you haven't found it on the list yet
                   {
                   //get the next item
                   %index++;
                   %item = getWord(%equipmentList, %index);
                   }
            }
            if(!%isWanted) //If this item isn't wanted
            {
                   //For now, just drop it.
                   //now select the weapon

                   echo("AI is dropping " @ %haveItem);
                   %client.player.use(%haveItem);
                   
                   //...and drop it!
                   %client.player.throwWeapon();
                   return true;
            }
      }
      //get the next item
      %haveIndex++;
      %haveItem = getWord(%AIEquipmentList, %haveIndex);
   }


	//made it through the list without finding anything that should go
    //This should happen when there are already empty slots
	return false;
}

function AIDropUnwantedPack(%equipmentList, %client)
{
   %haveIndex = 1; //the pack
   %haveItem = getWord(equipmentList, %haveIndex);

   if (!%client.player.getInventory(%haveItem) && %client.player.getMountedImage($BackpackSlot))
   {
   echo("AI is dropping pack" @ %haveItem);
   %client.player.throwPack();
   return true;
   }


   //If you got to here, the pack you want is one your back
   return false;
}

//To assist in deciding what type of item it is...
function ItemIsPack(%item)
{
   %type = %item;//%item.getDataBlock().getName();
   //Does NOT include sensor packs yet
   if (%type $= "EnergyPack" || %type $= "RepairPack" || %type $= "AmmoPack" || %type $= "ShieldPack" || %type $= "CloakPack" || %type $= "TurretIndoorDeployable" || %type $= "TurretOutdoorDeployable")
      return true; //Yes, its a pack.
   else
      return false; //Nope!
}

function ItemIsWeapon(%item)
{
   %type = %item;//%item.getDataBlock().getName();

   //Use the weapons list to determine what the item is
   %haveIndex = 0; //First weapon in list of possible equipment
   %haveItem = getWord(%AIEquipmentList, %haveIndex);

   //First, we need to establish what we have
   while (%haveItem !$= "")
   {
   if (%type $= %haveItem)
   return true; //Its a weapon.
   }
   return false; //Not!
}

//This function is used for finding a wanted item
function findItem( %type, %client )
{
     	%closestItem = -1;
		%closestDist = 32767;

		//search the AIItemSet for a repair pack (someone might have dropped one...)
		%itemCount = $AIItemSet.getCount();
		for (%i = 0; %i < %itemCount; %i++)
		{
			%item = $AIItemSet.getObject(%i);
			if (%item.getDataBlock().getName() $= %type && !%item.isHidden())
			{
				%dist = %client.getPathDistance(%item.getWorldBoxCenter());
				if (%dist > 0 && %dist < %closestDist)
				{
					%closestItem = %item;
					%closestDist = %dist;
				}
			}
		}
    if (%closestItem > 0)
    echo("Found a" @ %type);
    return %item;
    
    //This function does not yet take into account a situation where there
    //IS no such item on the map. Be careful.
}


//This is the code from the AI repairing task, which allows the bot to find
//a repair pack.

function moveTowardsItem( %item, %client )
{
echo("Moving towards item");
%client.stepMove(%item.position, 0.25);
}

